<?php

/*********************************************************************

 ニュースdisplayプラグイン (2014/08/22)

 freo.jp
 customize by 32877(http://32877.xii.jp)

*********************************************************************/

/* メイン処理 */
function freo_display_news()
{
	global $freo;

	//パラメータ検証
	if (!isset($_GET['page']) or !preg_match('/^\d+$/', $_GET['page']) or $_GET['page'] < 1) {
		$_GET['page'] = 1;
	}

	//検索条件設定
	$condition = null;
	if (isset($_GET['word'])) {
		$condition .= ' AND title LIKE ' . $freo->pdo->quote('%' . $_GET['word'] . '%') . ' OR text LIKE ' . $freo->pdo->quote('%' . $_GET['word'] . '%');
	}
	if (isset($_GET['category_id'])) {
		$condition .= ' AND category_id = ' . $freo->pdo->quote($_GET['category_id']);
	}
	if (isset($_GET['tag'])) {
		$condition .= ' AND tag = ' . $freo->pdo->quote($_GET['tag']) . ' OR tag LIKE ' . $freo->pdo->quote($_GET['tag'] . ',%') . ' OR tag LIKE ' . $freo->pdo->quote('%,' . $_GET['tag']) . ' OR tag LIKE ' . $freo->pdo->quote('%,' . $_GET['tag'] . ',%');
	}
	if (isset($_GET['date'])) {
		if (preg_match('/^\d\d\d\d$/', $_GET['date'])) {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$condition .= ' AND DATE_FORMAT(created, \'%Y\') = ' . $freo->pdo->quote($_GET['date']);
			} else {
				$condition .= ' AND STRFTIME(\'%Y\', created) = ' . $freo->pdo->quote($_GET['date']);
			}
		} elseif (preg_match('/^\d\d\d\d\d\d$/', $_GET['date'])) {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$condition .= ' AND DATE_FORMAT(created, \'%Y%m\') = ' . $freo->pdo->quote($_GET['date']);
			} else {
				$condition .= ' AND STRFTIME(\'%Y%m\', created) = ' . $freo->pdo->quote($_GET['date']);
			}
		} elseif (preg_match('/^\d\d\d\d\d\d\d\d$/', $_GET['date'])) {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$condition .= ' AND DATE_FORMAT(created, \'%Y%m%d\') = ' . $freo->pdo->quote($_GET['date']);
			} else {
				$condition .= ' AND STRFTIME(\'%Y%m%d\', created) = ' . $freo->pdo->quote($_GET['date']);
			}
		}
	}


	if ($condition) {
		$condition = ' WHERE id IS NOT NULL ' . $condition;
	}

	//検索条件
	$ascending = false;

		if ($freo->config['plugin']['news']['news_order'] == 'ascend') {
			$ascending = true;
		}

	if ($ascending == true) {
		$order = ' id';
	} else {
		$order = ' id DESC';
	}
	
	//ニュース取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_newses ' . $condition . ' ORDER BY' . $order . ' LIMIT :start, :limit');
	$stmt->bindValue(':start', intval($freo->config['plugin']['news']['utility_limit']) * ($_GET['page'] - 1), PDO::PARAM_INT);
	$stmt->bindValue(':limit', intval($freo->config['plugin']['news']['utility_limit']), PDO::PARAM_INT);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_newses = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_newses[$data['id']] = $data;
	}

	//ニュースID取得
	$plugin_news_keys = array_keys($plugin_newses);

	//ニュースタグ取得
	$plugin_news_tags = array();
	foreach ($plugin_news_keys as $plugin_news) {
		if (!$plugin_newses[$plugin_news]['tag']) {
			continue;
		}

		$plugin_news_tags[$plugin_news] = explode(',', $plugin_newses[$plugin_news]['tag']);
	}

	//ファイル取得
	$plugin_news_files = array();
	foreach ($plugin_news_keys as $plugin_news) {
		$file_dir = FREO_FILE_DIR . 'plugins/news_files/' . $plugin_news . '/';
		$thumbnail_dir = FREO_FILE_DIR . 'plugins/news_thumbnails/' . $plugin_news . '/';

		if (file_exists($file_dir)) {
			if ($dir = scandir($file_dir)) {
				foreach ($dir as $data) {
					if (is_file($file_dir . $data) and preg_match("/(\w+)\.\w+$/", $data, $matches)) {
						list($width, $height, $size) = freo_file($file_dir . $data);
						if (is_file($thumbnail_dir . $data) and preg_match("/(\w+)\.\w+$/", $data, $matches)) {
							list($thumbnailwidth, $thumbnailheight, $thumbnailsize) = freo_file($thumbnail_dir . $data);
							$thumbnail = array(
								'name'    => $data,
								'width'   => $thumbnailwidth,
								'height'  => $thumbnailheight,
								'size'    => $thumbnailsize
							);
						} else {
							$thumbnail = array();
						}
						$plugin_news_files[$plugin_news][$matches[1]] = array(
							'name'      => $data,
							'width'     => $width,
							'height'    => $height,
							'size'      => $size,
							'thumbnail' => $thumbnail
						);
					}
				}
			} else {
				freo_error('ファイル保存ディレクトリを開けません。');
			}
		}
	}

	//ニュース数・ページ数取得
	$stmt = $freo->pdo->query('SELECT COUNT(*) FROM ' . FREO_DATABASE_PREFIX . 'plugin_newses ' . $condition);
	if (!$stmt) {
		freo_error($freo->pdo->errorInfo());
	}

	$data                  = $stmt->fetch(PDO::FETCH_NUM);
	$plugin_news_count = $data[0];
	$plugin_news_page  = ceil($plugin_news_count / $freo->config['plugin']['news']['utility_limit']);

	//カテゴリー取得
	$stmt = $freo->pdo->query('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_news_categories ORDER BY sort, id');
	if (!$stmt) {
		freo_error($freo->pdo->errorInfo());
	}

	$plugin_news_categories = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_news_categories[$data['id']] = $data;
	}

	//データ割当
	$freo->smarty->assign(array(
		'token'                 => freo_token('create'),
		'plugin_newses'      => $plugin_newses,
		'plugin_news_tags'  => $plugin_news_tags,
		'plugin_news_files' => $plugin_news_files,
		'plugin_news_count' => $plugin_news_count,
		'plugin_news_page'  => $plugin_news_page,
		'plugin_news_categories'  => $plugin_news_categories
	));

	return;
}

?>
